var EditorVar=[];
EditorVar.log=[];
EditorVar.now=[];
EditorVar.EventStoped=[];
EditorVar.Textarea=[];
EditorVar.HTML=[];
var EditorLoad=0;

EditorSet();
if(window.EditorLoadFunction) EditorLoadFunction();

function EditorSet(){
	if(EditorLoad) return;
	EditorLoad=1;
	var obj=[];
	var element;
	if(document.getElementsByClassName){
		element=document.getElementsByClassName("editor");
	}else{
		element=document.getElementsByTagName("textarea");
	}
	for(var i=0;i<element.length;i++){
		if(element[i].className!='editor') continue;
		var code=element[i].value;
		var width=element[i].style.width || "100%";
		var height=element[i].style.height || "280px";
		obj[0]=document.createElement("div");
		obj[0].style.width=width;
		obj[0].style.border="1px solid";
		obj[0].style.position="relative";
		element[i].parentNode.insertBefore(obj[0],element[i]);
		obj[1]=document.createElement("div");
		obj[1].id="editor_"+i+"_MENU";
		obj[1].style.width="100%";
		obj[1].style.borderBottom="1px solid";
		obj[1].style.position="relative";
		obj[2]=document.createElement("div");
		obj[2].style.position="absolute";
		obj[2].style.right="0px";
		obj[2].style.padding="1px 5px";
		obj[3]=document.createElement("a");
		obj[3].id="editor_"+i+"_BUTTON_mode";
		obj[3].appendChild(document.createTextNode("ソース"));
		obj[3].title="モード切り替え";
		obj[3].href="javascript:EditorModeChange("+i+")";
		obj[2].appendChild(obj[3]);
		obj[1].appendChild(obj[2]);
		obj[2]=document.createElement("span");
		obj[2].style.padding="1px 5px";
		obj[2].style.display="inline-block";
		obj[3]=document.createElement("a");
		obj[3].appendChild(document.createTextNode("<B>"));
		obj[3].title="太字";
		obj[3].href="javascript:EditorInlineInsert("+i+",'b')";
		obj[2].appendChild(obj[3]);
		obj[3]=document.createElement("a");
		obj[3].appendChild(document.createTextNode("<I>"));
		obj[3].title="斜体";
		obj[3].href="javascript:EditorInlineInsert("+i+",'i')";
		obj[2].appendChild(obj[3]);
		obj[3]=document.createElement("a");
		obj[3].appendChild(document.createTextNode("<S>"));
		obj[3].title="打ち消し線";
		obj[3].href="javascript:EditorInlineInsert("+i+",'s')";
		obj[2].appendChild(obj[3]);
		obj[3]=document.createElement("a");
		obj[3].appendChild(document.createTextNode("<U>"));
		obj[3].title="下線";
		obj[3].href="javascript:EditorInlineInsert("+i+",'u')";
		obj[2].appendChild(obj[3]);
		obj[1].appendChild(obj[2]);
		obj[2]=document.createElement("span");
		obj[2].style.padding="0px 5px";
		obj[2].style.display="inline-block";
		obj[3]=document.createElement("a");
		obj[3].appendChild(document.createTextNode("<UL>"));
		obj[3].title="リスト（番号なし）";
		obj[3].href="javascript:EditorListInsert("+i+",'ul')";
		obj[2].appendChild(obj[3]);
		obj[3]=document.createElement("a");
		obj[3].appendChild(document.createTextNode("<OL>"));
		obj[3].title="リスト（番号つき）";
		obj[3].href="javascript:EditorListInsert("+i+",'ol')";
		obj[2].appendChild(obj[3]);
		obj[1].appendChild(obj[2]);
		obj[2]=document.createElement("span");
		obj[2].style.padding="1px 5px";
		obj[2].style.display="inline-block";
		obj[3]=document.createElement("a");
		obj[3].appendChild(document.createTextNode("<SPAN>"));
		obj[3].title="インライン修飾";
		obj[3].href="javascript:EditorInlineInsert("+i+",'span')";
		obj[2].appendChild(obj[3]);
		obj[3]=document.createElement("a");
		obj[3].appendChild(document.createTextNode("<DIV>"));
		obj[3].title="通常ブロック";
		obj[3].href="javascript:EditorBlockInsert("+i+",'div')";
		obj[2].appendChild(obj[3]);
		obj[1].appendChild(obj[2]);
		obj[2]=document.createElement("span");
		obj[2].style.padding="0px 5px";
		obj[2].style.display="inline-block";
		obj[3]=document.createElement("a");
		obj[3].appendChild(document.createTextNode("<A>"));
		obj[3].title="リンク";
		obj[3].href="javascript:EditorLinkProperty("+i+")";
		obj[2].appendChild(obj[3]);
		obj[1].appendChild(obj[2]);
		obj[2]=document.createElement("span");
		obj[2].style.padding="0px 5px";
		obj[2].style.display="inline-block";
		obj[3]=document.createElement("a");
		obj[3].appendChild(document.createTextNode("<IMG>"));
		obj[3].title="画像";
		obj[3].href="javascript:EditorImageProperty("+i+")";
		obj[2].appendChild(obj[3]);
		obj[1].appendChild(obj[2]);
		obj[2]=document.createElement("span");
		obj[2].style.padding="0px 5px";
		obj[2].style.display="inline-block";
		obj[3]=document.createElement("a");
		obj[3].appendChild(document.createTextNode("<TABLE>"));
		obj[3].title="表組み";
		obj[3].href="javascript:EditorTableProperty("+i+")";
		obj[2].appendChild(obj[3]);
		obj[1].appendChild(obj[2]);
		obj[0].appendChild(obj[1]);
		obj[1]=document.createElement("div");
		obj[0].appendChild(obj[1]);
		obj[1].style.width=width;
		obj[2]=document.createElement("div");
		obj[1].appendChild(obj[2]);
		obj[2].style.height=height;
		obj[2].style.overflow="auto";
		obj[2].style.padding="3px";
		obj[2].contentEditable=true;
		obj[2].innerHTML=code||"<br />";
		EditorVar.HTML[i]=obj[2];
		obj[2]=element[i].parentNode.removeChild(element[i]);
		obj[2].style.display="none";
		obj[2].style.width=width;
		obj[2].style.height=height;
		obj[2].style.borderWidth="0px";
		obj[2].style.margin="0px";
		obj[2].style.padding="3px 0px";
		EditorVar.Textarea[i]=obj[2];
		obj[1].appendChild(obj[2]);
		EditorVar.log[i]=[];
		EditorVar.log[i][0]=code;
		EditorVar.now[i]=0;
		EditorVar.EventStoped[i]=[];
		(function(i){
			if(element[i].addEventListener){
				EditorVar.HTML[i].addEventListener('blur',function(e){EditorTextareaUpdate(i);e.stopPropagation()},true);
				EditorVar.HTML[i].addEventListener('contextmenu',function(e){EditorContextOpen(e,i);e.stopPropagation()},true);
				EditorVar.HTML[i].addEventListener('focus',function(e){EditorFocus(i);e.stopPropagation()},true);
				EditorVar.HTML[i].addEventListener('keydown',function(e){EditorKeyDown(e,i);e.stopPropagation()},true);
				EditorVar.HTML[i].addEventListener('keypress',function(e){EditorKeyPress(e,i);e.stopPropagation()},true);
				EditorVar.HTML[i].addEventListener('keyup',function(e){EditorKeyUp(e,i);e.stopPropagation()},true);

				EditorVar.EventStoped[i].blur=1;
				EditorVar.EventStoped[i].contextmenu=1;
				EditorVar.EventStoped[i].focus=1;
				EditorVar.EventStoped[i].keydown=1;
				EditorVar.EventStoped[i].keypress=1;
				EditorVar.EventStoped[i].keyup=1;
			}else{
				EditorVar.HTML[i].attachEvent('onfocus',function(){EditorFocus(i)});
				EditorVar.HTML[i].attachEvent('onblur',function(){EditorTextareaUpdate(i)});
				EditorVar.HTML[i].attachEvent('oncontextmenu',function(e){EditorContextOpen(e,i)});
				EditorVar.HTML[i].attachEvent('onkeydown',function(e){EditorKeyDown(e,i)});
				EditorVar.HTML[i].attachEvent('onkeyup',function(e){EditorKeyUp(e,i)});
//				EditorVar.HTML[i].attachEvent('onkeypress',function(e){EditorKeyPress(e,i)});
			}
		})(i);
		EditorHtmlInsert(i);
	}
}
function EditorFocus(i){
	EditorVar.focus=i;
}
function EditorKeyDown(e,i){
	if(!e) e=event;
	if(e.keyCode==13){
		if(EditorVar.input){
			EditorVar.input=0;
			EditorLogUpdate(i);
		}
	}else if(e.keyCode==17){
		EditorVar.keyctrl=1;
	}else if(e.keyCode==16){
		EditorVar.keyshift=1;
	}else if(EditorVar.keyctrl && EditorVar.keyshift && e.keyCode==90){
		EditorRedo(i);
		e.preventDefault();
		e.returnValue=false;
	}else if(EditorVar.keyctrl && e.keyCode==90){
		EditorUndo(i);
		e.preventDefault();
		e.returnValue=false;
	}else{
		EditorVar.input=1;
	}
}
function EditorKeyUp(e,i){
	if(!e) e=event;
	if(e.keyCode==17){
		EditorVar.keyctrl=0;
	}else if(e.keyCode==16){
		EditorVar.keyshift=0;
	}
}
function EditorKeyPress(e,i){
	if(!e) e=event;
	if(e.keyCode==13){
		EditorVar.keyctrl=0;
		if(e.preventDefault){
			var sel=getSelection();
			if(sel.rangeCount>1) return;
			e.preventDefault();
			var range=sel.getRangeAt(0);
			var df=document.createDocumentFragment();
			df.appendChild(document.createElement('br'));
			if(window.opera){
				var text=document.createTextNode("");
			}else{
				var text=document.createTextNode("\n");
			}
			df.appendChild(text);
			range.deleteContents();
			range.insertNode(df);
			if(!document.all){
				if(text.nextSibling && text.nextSibling.nodeType==3 && text.nextSibling.length==0) text.parentNode.removeChild(text.nextSibling);
				if(text==text.parentNode.lastChild) text.parentNode.appendChild(document.createElement('br'));
			}
			sel.collapse(text,text.length);
			var span=document.createElement('span');
			span.style.display="inline-block";
			span.innerHTML="&nbsp;";
			text.parentNode.insertBefore(span,text.nextSibling);
			if(span.offsetTop+span.clientHeight>EditorVar.HTML[i].clientHeight+EditorVar.HTML[i].scrollTop){
				EditorVar.HTML[i].scrollTop+=span.clientHeight;
			}
			span.parentNode.removeChild(span);
			sel.collapse(text,text.length);
		}
	}
}
function EditorTextareaUpdate(i){
	var code=EditorVar.HTML[i].innerHTML;
	code=code.replace(/^\s+/,'');
	code=code.replace(/\s+$/,'');
	code+="\n";
	EditorVar.Textarea[i].value=code;
}
function EditorLogUpdate(i){
	var code=EditorVar.HTML[i].innerHTML;
	if((!code && !EditorVar.now[i]) || code==EditorVar.log[i][EditorVar.now[i]]) return;
	EditorVar.log[i][EditorVar.now[i]+1]=code;
	EditorVar.log[i].splice(EditorVar.now[i]+2);
	EditorVar.now[i]=EditorVar.log[i].length-1;
	if(EditorVar.log[i].length>50){
		EditorVar.log[i].shift;
		EditorVar.now[i]--;
	}
}
function EditorUndo(i){
	if(!EditorVar.now[i]) return;
	if(EditorVar.now[i]+1==EditorVar.log[i].length) EditorLogUpdate(i);
	EditorVar.HTML[i].innerHTML=EditorVar.log[i][EditorVar.now[i]-1];
	EditorVar.now[i]--;
	EditorContextClose();
	EditorTextareaUpdate(i);
}
function EditorRedo(i){
	if(EditorVar.now[i]+2>EditorVar.log[i].length) return;
	EditorVar.HTML[i].innerHTML=EditorVar.log[i][EditorVar.now[i]+1];
	EditorVar.now[i]++;
	EditorContextClose();
	EditorTextareaUpdate(i);
}
function EditorTableProperty(i,tag){
	if(document.getElementById("editor_Property")) return;
	EditorContextClose();
	var col,row,bw,bs,bc,borderColor,padding,width,style;
	if(tag){
		row=0;
		col=0;
		for(var j=0;j<tag.childNodes.length;j++){
			if(tag.childNodes[j].tagName && tag.childNodes[j].tagName.toUpperCase()=="TBODY"){
				for(var k=0;k<tag.childNodes[j].childNodes.length;k++){
					if(tag.childNodes[j].childNodes[k].tagName && tag.childNodes[j].childNodes[k].tagName.toUpperCase()=="TR"){
						row++;
						var x=0;
						for(var l=0;l<tag.childNodes[j].childNodes[k].childNodes.length;l++){
							if(tag.childNodes[j].childNodes[k].childNodes[l].tagName && (tag.childNodes[j].childNodes[k].childNodes[l].tagName.toUpperCase()=="TD" || tag.childNodes[j].childNodes[k].childNodes[l].tagName.toUpperCase()=="TH")){
								if(tag.childNodes[j].childNodes[k].childNodes[l].colSpan){
									x+=tag.childNodes[j].childNodes[k].childNodes[l].colSpan;
								}else{
									x++;
								}
							}
						}
						if(x>col) col=x;
					}
				}
			}
		}
		width=tag.style.width;
		bw=tag.style.borderWidth;
		bs=tag.style.borderStyle;
		borderColor=tag.style.borderColor;
		bc=tag.style.borderCollapse;
		padding="0px 3px";
		style=tag.style.cssText;
		if(style && !style.match(/;$/)) style+=";";
		style=style.replace(/^width:[^;]*;/ig,"");
		style=style.replace(/\swidth:[^;]*;/ig,"");
		style=style.replace(/^border[^:]*:[^;]*;/ig,"");
		style=style.replace(/\sborder[^:]*:[^;]*;/ig,"");
		style=style.replace(/^\s+/,"");
		style=style.replace(/\s+$/,"");
	}else if(window.getSelection){
		var sel=getSelection();
		var range=sel.getRangeAt(0);
		var node=range.commonAncestorContainer;
		if(!EditorVar.HTML[i].contains(node)) range="";
		bw="1px";
		bs="solid";
		borderColor="black";
		bc="collapse";
		padding="0px 3px";
	}else{
		bw="1px";
		bs="solid";
		borderColor="black";
		bc="collapse";
		padding="0px 3px";
	}
	var obj=[];
	obj[0]=document.createElement("div");
	obj[0].id="editor_Property";
	obj[0].style.backgroundColor="white";
	obj[0].style.width="100%";
	obj[0].style.height="100%";
	obj[0].style.position="absolute";
	obj[0].style.overflow="auto";
	obj[0].style.top="0px";
	obj[0].style.left="0px";
	EditorVar.HTML[i].parentNode.appendChild(obj[0]);
	obj[1]=document.createElement("div");
	obj[1].style.fontWeight="bold";
	obj[1].style.margin="10px 10px 0px";
	obj[1].appendChild(document.createTextNode("テーブル設定"));
	obj[0].appendChild(obj[1]);

	obj[1]=document.createElement("span");
	obj[1].style.display="inline-block";
	obj[1].style.margin="10px";
	obj[1].style.verticalAlign="top";
	obj[1].appendChild(document.createTextNode("列数:"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TABLE_cols";
	obj[3].value=col || 2;
	obj[3].style.width="35px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createTextNode("　行数:"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TABLE_rows";
	obj[3].value=row || 2;
	obj[3].style.width="35px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TABLE_width";
	obj[3].value=width || '';
	obj[3].style.width="60px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createTextNode(":width"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TABLE_bw";
	obj[3].value=bw || '';
	obj[3].style.width="60px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="ボーダー幅";
	obj[3].appendChild(document.createTextNode(":border-width"));
	obj[3].href="javascript:EditorStyleRotate('border-width','editor_TABLE_bw')";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TABLE_bs";
	obj[3].value=bs || '';
	obj[3].style.width="60px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="ボーダー形状";
	obj[3].appendChild(document.createTextNode(":border-style"));
	obj[3].href="javascript:EditorStyleRotate('border-style','editor_TABLE_bs')";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TABLE_borderColor";
	if(borderColor) obj[3].value=borderColor;
	obj[3].style.width="60px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="ボーダー色";
	obj[3].appendChild(document.createTextNode(":border-color"));
	obj[3].href="javascript:void(0)";
	(function(i,obj){
		if(window.addEventListener){
			obj.addEventListener('click',function(e){EditorPickerOpen(e,i,'editor_TABLE_borderColor')},false);
		}else{
			obj.attachEvent('onclick',function(e){EditorPickerOpen(e,i,'editor_TABLE_borderColor')});
		}
	})(i,obj[3]);
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TABLE_bc";
	obj[3].value=bc || '';
	obj[3].style.width="60px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createTextNode(":border-collapse"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TABLE_padding";
	obj[3].value=padding;
	obj[3].style.width="60px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createTextNode(":padding（セル内余白）"));
	obj[1].appendChild(document.createElement("br"));
	obj[0].appendChild(obj[1]);

	obj[2]=document.createElement("span");
	obj[2].style.display="inline-block";
	obj[2].style.margin="10px";
	obj[2].style.verticalAlign="top";
	obj[2].appendChild(document.createTextNode("style"));
	obj[2].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TABLE_style";
	obj[3].value=style || '';
	obj[2].appendChild(obj[3]);
	obj[0].appendChild(obj[2]);

	obj[1]=document.createElement("div");
	obj[1].style.margin="30px 10px 0px";
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("決定"));
	obj[2].href="javascript:void(0)";
	obj[2].id="editor_TABLE_set";
	obj[1].appendChild(obj[2]);
	obj[1].appendChild(document.createTextNode("　"));
	if(tag){
		obj[2]=document.createElement("a");
		obj[2].appendChild(document.createTextNode("テーブル削除"));
		obj[2].href="javascript:void(0)";
		obj[2].id="editor_TagDelete";
		obj[1].appendChild(obj[2]);
		obj[1].appendChild(document.createTextNode("　"));
	}
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("キャンセル"));
	obj[2].href="javascript:EditorPropertyClose()";
	obj[1].appendChild(obj[2]);
	obj[0].appendChild(obj[1]);
	(function(i,tag,range){
		if(window.addEventListener){
			document.getElementById("editor_TABLE_set").addEventListener('click',function(){EditorTableSet(i,tag,range)},false);
			if(document.getElementById("editor_TagDelete")) document.getElementById("editor_TagDelete").addEventListener('click',function(){EditorTagDelete(i,tag)},false);
		}else{
			document.getElementById("editor_TABLE_set").attachEvent('onclick',function(){EditorTableSet(i,tag,range)});
			if(document.getElementById("editor_TagDelete")) document.getElementById("editor_TagDelete").attachEvent('onclick',function(){EditorTagDelete(i,tag)});
		}
	})(i,tag,range);
}
function EditorTableSet(i,tag,range){
	EditorLogUpdate(i);
	var col=document.getElementById("editor_TABLE_cols").value || 2;
	var row=document.getElementById("editor_TABLE_rows").value || 2;
	var width=document.getElementById("editor_TABLE_width").value;
	if(width.match(/\d+$/)) width+="px";
	var bw=document.getElementById("editor_TABLE_bw").value;
	if(bw.match(/\d+$/)) bw+="px";
	var bs=document.getElementById("editor_TABLE_bs").value;
	var borderColor=document.getElementById("editor_TABLE_borderColor").value;
	var bc=document.getElementById("editor_TABLE_bc").value;
	var padding=document.getElementById("editor_TABLE_padding").value;
	var style=document.getElementById("editor_TABLE_style").value;
	if(tag){
		tag.removeAttribute("style");
 		if(style) tag.setAttribute("style",style);
		if(width) tag.style.width=width;
		if(bw) tag.style.borderWidth=bw;
		if(bs) tag.style.borderStyle=bs;
		if(borderColor) tag.style.borderColor=borderColor;
		if(bc) tag.style.borderCollapse="collapse";
		for(var j=0;j<tag.childNodes.length;j++){
			if(tag.childNodes[j].tagName && tag.childNodes[j].tagName.toUpperCase()=="TBODY"){
				var y=0;
				for(var k=0;k<tag.childNodes[j].childNodes.length;k++){
					if(tag.childNodes[j].childNodes[k].tagName && tag.childNodes[j].childNodes[k].tagName.toUpperCase()=="TR"){
						y++;
						if(y>row){
							for(var l=tag.childNodes[j].childNodes.length-1;l>=k;l--){
								if(tag.childNodes[j].childNodes[l].tagName && tag.childNodes[j].childNodes[l].tagName.toUpperCase()=="TR"){
									tag.childNodes[j].removeChild(tag.childNodes[j].childNodes[l]);
								}
							}
							break;
						}
						var x=0;
						for(var l=0;l<tag.childNodes[j].childNodes[k].childNodes.length;l++){
							if(tag.childNodes[j].childNodes[k].childNodes[l].tagName && (tag.childNodes[j].childNodes[k].childNodes[l].tagName.toUpperCase()=="TD" || tag.childNodes[j].childNodes[k].childNodes[l].tagName.toUpperCase()=="TH")){
								if(x>=col){
									for(var m=tag.childNodes[j].childNodes[k].childNodes.length-1;m>=l;m--){
										if(tag.childNodes[j].childNodes[k].childNodes[m].tagName && (tag.childNodes[j].childNodes[k].childNodes[m].tagName.toUpperCase()=="TD" || tag.childNodes[j].childNodes[k].childNodes[m].tagName.toUpperCase()=="TH")){
											tag.childNodes[j].childNodes[k].removeChild(tag.childNodes[j].childNodes[k].childNodes[m]);
										}
									}
									break;
								}
								if(bw) tag.childNodes[j].childNodes[k].childNodes[l].style.borderWidth=bw;
								if(bs) tag.childNodes[j].childNodes[k].childNodes[l].style.borderStyle=bs;
								if(borderColor) tag.childNodes[j].childNodes[k].childNodes[l].style.borderColor=borderColor;
								if(tag.childNodes[j].childNodes[k].childNodes[l].colSpan){
									x+=tag.childNodes[j].childNodes[k].childNodes[l].colSpan;
								}else{
									x++;
								}
							}
						}
						for(var l=x;l<col;l++){
							var td=document.createElement("td");
							if(bw) td.style.borderWidth=bw;
							if(bs) td.style.borderStyle=bs;
							if(borderColor) td.style.borderColor=borderColor;
							if(padding) td.style.padding=padding;
							td.innerHTML="&nbsp;";
							tag.childNodes[j].childNodes[k].appendChild(td);
						}
					}
				}
				for(var k=y;k<row;k++){
					tag.childNodes[j].appendChild(document.createElement("tr"));
					for(var l=0;l<col;l++){
						var td=document.createElement("td");
						if(bw) td.style.borderWidth=bw;
						if(bs) td.style.borderStyle=bs;
						if(borderColor) td.style.borderColor=borderColor;
						if(padding) td.style.padding=padding;
						td.innerHTML="&nbsp;";
						tag.childNodes[j].childNodes[k].appendChild(td);
					}
				}
			}
		}
	}else{
		var table=document.createElement("table");
 		if(style) table.setAttribute("style",style);
		if(width) table.style.width=width;
		if(bw) table.style.borderWidth=bw;
		if(bs) table.style.borderStyle=bs;
		if(borderColor) table.style.borderColor=borderColor;
		if(bc) table.style.borderCollapse="collapse";
		var tbody=document.createElement("tbody");
		table.appendChild(tbody);
		for(y=0;y<row;y++){
			var tr=document.createElement("tr");
			tbody.appendChild(tr);
			for(x=0;x<col;x++){
				var td=document.createElement("td");
				if(bw) td.style.borderWidth=bw;
				if(bs) td.style.borderStyle=bs;
				if(borderColor) td.style.borderColor=borderColor;
				if(padding) td.style.padding=padding;
				td.innerHTML="&nbsp;";
				tr.appendChild(td);
			}
		}
		if(range){
			range.insertNode(table);
		}else{
			EditorVar.HTML[i].appendChild(table);
			EditorVar.HTML[i].appendChild(document.createElement("br"));
		}
	}
	EditorPropertyClose();
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorLinkProperty(i,tag){
	if(document.getElementById("editor_Property")) return;
	EditorContextClose();
	var text,href,target,style;
	if(tag){
		text=tag.textContent||tag.innerText;
		href=tag.href;
		target=tag.target;
		style=tag.style.cssText;
		style=style.replace(/^\s+/,"");
		style=style.replace(/\s+$/,"");
	}else if(window.getSelection){
		var sel=getSelection();
		var range=sel.getRangeAt(0);
		var node=range.commonAncestorContainer;
		if(EditorVar.HTML[i].contains(node)){
			var ok=1;
		}
		if(!ok){
			range="";
		}else if(range.startContainer.nodeType==1 && range.startContainer.childNodes[range.startOffset].tagName && range.startContainer.childNodes[range.startOffset].tagName.toUpperCase()=="IMG"){
			var node=range.startContainer.childNodes[range.startOffset];
			range.setStart(node,0);
		}
		if(range) text=range.toString();
	}else if(document.selection){
		var range=document.selection.createRange();
		if(range.text){
			text=range.text;
		}else{
			range="";
		}
	}
	if(!href && text && text.match(/^https?:/)) href=text;
	var obj=[];
	obj[0]=document.createElement("div");
	obj[0].id="editor_Property";
	obj[0].style.backgroundColor="white";
	obj[0].style.width="100%";
	obj[0].style.height="100%";
	obj[0].style.position="absolute";
	obj[0].style.overflow="auto";
	obj[0].style.top="0px";
	obj[0].style.left="0px";
	EditorVar.HTML[i].parentNode.appendChild(obj[0]);
	obj[1]=document.createElement("div");
	obj[1].style.fontWeight="bold";
	obj[1].style.margin="10px 10px 0px";
	obj[1].appendChild(document.createTextNode("リンク設定"));
	obj[0].appendChild(obj[1]);

	obj[1]=document.createElement("span");
	obj[1].style.display="inline-block";
	obj[1].style.margin="10px";
	obj[1].style.verticalAlign="top";
	obj[1].appendChild(document.createTextNode("href"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_LINK_href";
	obj[3].value=href || '';
	obj[3].style.width="300px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[1].appendChild(document.createElement("br"));
	obj[1].appendChild(document.createTextNode("文字列"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_LINK_text";
	obj[3].value=text || '';
	obj[3].style.width="300px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("a");
	obj[3].title="リンク先表示フレーム";
	obj[3].appendChild(document.createTextNode("target"));
	obj[3].href="javascript:EditorStyleRotate('target','editor_LINK_target')";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_LINK_target";
	obj[3].value=target || '';
	obj[1].appendChild(obj[3]);
	obj[0].appendChild(obj[1]);

	obj[2]=document.createElement("span");
	obj[2].style.display="inline-block";
	obj[2].style.margin="10px";
	obj[2].style.verticalAlign="top";
	obj[2].appendChild(document.createTextNode("style"));
	obj[2].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_LINK_style";
	obj[3].value=style || '';
	obj[2].appendChild(obj[3]);
	obj[0].appendChild(obj[2]);

	obj[1]=document.createElement("div");
	obj[1].style.margin="30px 10px 0px";
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("決定"));
	obj[2].href="javascript:void(0)";
	obj[2].id="editor_LINK_set";
	obj[1].appendChild(obj[2]);
	obj[1].appendChild(document.createTextNode("　"));
	if(tag){
		obj[2]=document.createElement("a");
		obj[2].appendChild(document.createTextNode("タグ解除"));
		obj[2].href="javascript:void(0)";
		obj[2].id="editor_TagRelease";
		obj[1].appendChild(obj[2]);
		obj[1].appendChild(document.createTextNode("　"));
	}
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("キャンセル"));
	obj[2].href="javascript:EditorPropertyClose()";
	obj[1].appendChild(obj[2]);
	obj[0].appendChild(obj[1]);
	(function(i,tag,range){
		if(window.addEventListener){
			document.getElementById("editor_LINK_set").addEventListener('click',function(){EditorLinkSet(i,tag,range)},false);
			if(document.getElementById("editor_TagRelease")) document.getElementById("editor_TagRelease").addEventListener('click',function(){EditorTagRelease(i,tag)},false);
		}else{
			document.getElementById("editor_LINK_set").attachEvent('onclick',function(){EditorLinkSet(i,tag,range)});
			if(document.getElementById("editor_TagRelease")) document.getElementById("editor_TagRelease").attachEvent('onclick',function(){EditorTagRelease(i,tag)});
		}
	})(i,tag,range);
}
function EditorLinkSet(i,tag,range){
	EditorLogUpdate(i);
	var text=document.getElementById("editor_LINK_text").value;
	var href=document.getElementById("editor_LINK_href").value;
	var target=document.getElementById("editor_LINK_target").value;
	var style=document.getElementById("editor_LINK_style").value;
	if(tag){
		if(text=="") text=href;
		tag.removeAttribute("style");
		tag.removeAttribute("href");
		tag.removeAttribute("target");
		if(style) tag.setAttribute("style",style);
		if(href) tag.href=href;
		if(target) tag.target=target;
		var rep;
		for(j=tag.childNodes.length-1;j>=0;j--){
			if(tag.childNodes[j].nodeType==3){
				if(!rep){
					tag.replaceChild(document.createTextNode(text),tag.childNodes[j]);
					rep=1;
				}else{
					tag.removeChild(tag.childNodes[j]);
				}
			}
		}
	}else if(range){
		var obj=document.createElement("a");
		if(style) obj.setAttribute("style",style);
		if(href) obj.href=href;
		if(target) obj.target=target;
		if(range.startContainer){
			obj.appendChild(range.extractContents());
			range.insertNode(obj);
		}else{
			var a="<a";
			if(href) a+=" href='"+href+"'";
			if(target) a+=" target='"+target+"'";
			if(style) a+=" style='"+style+"'";
			range.pasteHTML(a+">"+text+"</a>");
		}
	}else{
		var obj=document.createElement("a");
		if(style) obj.setAttribute("style",style);
		if(href) obj.href=href;
		if(target) obj.target=target;
		if(text=="") text=href;
		obj.appendChild(document.createTextNode(text));
		EditorVar.HTML[i].appendChild(obj);
		EditorVar.HTML[i].appendChild(document.createElement("br"));
	}
	EditorPropertyClose();
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorImageProperty(i,tag){
	if(document.getElementById("editor_Property")) return;
	EditorContextClose();
	var src,href,target,width,height,borderWidth,style;
	if(tag){
		src=tag.src;
		width=tag.style.width;
		height=tag.style.height;
		borderWidth=tag.style.borderWidth;
		style=tag.style.cssText;
		if(style && !style.match(/;$/)) style+=";";
		style=style.replace(/^border[^:]*:[^;]*;/ig,"");
		style=style.replace(/\sborder[^:]*:[^;]*;/ig,"");
		style=style.replace(/^width *:[^;]*;/ig,"");
		style=style.replace(/\swidth *:[^;]*;/ig,"");
		style=style.replace(/^height *:[^;]*;/ig,"");
		style=style.replace(/\sheight *:[^;]*;/ig,"");
		style=style.replace(/^\s+/,"");
		style=style.replace(/\s+$/,"");
	}else if(window.getSelection){
		var sel=getSelection();
		var range=sel.getRangeAt(0);
		var node=range.commonAncestorContainer;
		if(EditorVar.HTML[i].contains(node)){
			var ok=1;
		}
		if(!ok){
			if(range.startContainer==EditorVar.HTML[i]){
				var node=document.createTextNode("");
				range.startContainer.insertBefore(node,range.startContainer.childNodes[range.startOffset]);
				range.setStart(node,0);
			}else{
				range="";
			}
		}
		if(!borderWidth) borderWidth="0px";
	}else{
		borderWidth="0px";
	}
	var obj=[];
	obj[0]=document.createElement("div");
	obj[0].id="editor_Property";
	obj[0].style.backgroundColor="white";
	obj[0].style.width="100%";
	obj[0].style.height="100%";
	obj[0].style.position="absolute";
	obj[0].style.overflow="auto";
	obj[0].style.top="0px";
	obj[0].style.left="0px";
	EditorVar.HTML[i].parentNode.appendChild(obj[0]);
	obj[1]=document.createElement("div");
	obj[1].style.fontWeight="bold";
	obj[1].style.margin="10px 10px 0px";
	obj[1].appendChild(document.createTextNode("画像設定"));
	obj[0].appendChild(obj[1]);

	obj[1]=document.createElement("span");
	obj[1].style.display="inline-block";
	obj[1].style.margin="10px";
	obj[1].style.verticalAlign="top";
	obj[1].appendChild(document.createTextNode("src"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_Image_src";
	if(src) obj[3].value=src;
	obj[3].style.width="300px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_Image_width";
	if(width) obj[3].value=width;
	obj[3].style.width="50px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createTextNode(":width"));
	obj[1].appendChild(document.createElement("br"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_Image_height";
	if(height) obj[3].value=height;
	obj[3].style.width="50px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createTextNode(":height"));
	obj[1].appendChild(document.createElement("br"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_Image_borderWidth";
	if(borderWidth) obj[3].value=borderWidth;
	obj[3].style.width="50px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createTextNode(":border-width"));
	obj[1].appendChild(document.createElement("br"));
	obj[0].appendChild(obj[1]);

	obj[2]=document.createElement("span");
	obj[2].style.display="inline-block";
	obj[2].style.margin="10px";
	obj[2].style.verticalAlign="top";
	obj[2].appendChild(document.createTextNode("style"));
	obj[2].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_Image_style";
	if(style) obj[3].value=style;
	obj[2].appendChild(obj[3]);
	obj[0].appendChild(obj[2]);

	obj[1]=document.createElement("div");
	obj[1].style.margin="30px 10px 0px";
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("決定"));
	obj[2].href="javascript:void(0)";
	obj[2].id="editor_Image_set";
	obj[1].appendChild(obj[2]);
	obj[1].appendChild(document.createTextNode("　"));
	if(tag){
		obj[2]=document.createElement("a");
		obj[2].appendChild(document.createTextNode("画像削除"));
		obj[2].href="javascript:void(0)";
		obj[2].id="editor_TagRelease";
		obj[1].appendChild(obj[2]);
		obj[1].appendChild(document.createTextNode("　"));
	}
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("キャンセル"));
	obj[2].href="javascript:EditorPropertyClose()";
	obj[1].appendChild(obj[2]);
	obj[0].appendChild(obj[1]);
	(function(i,tag,range){
		if(window.addEventListener){
			document.getElementById("editor_Image_set").addEventListener('click',function(){EditorImageSet(i,tag,range)},false);
			if(document.getElementById("editor_TagRelease")) document.getElementById("editor_TagRelease").addEventListener('click',function(){EditorTagRelease(i,tag)},false);
		}else{
			document.getElementById("editor_Image_set").attachEvent('onclick',function(){EditorImageSet(i,tag,range)});
			if(document.getElementById("editor_TagRelease")) document.getElementById("editor_TagRelease").attachEvent('onclick',function(){EditorTagRelease(i,tag)});
		}
	})(i,tag,range);
}
function EditorImageSet(i,tag,range){
	EditorLogUpdate(i);
	var src=document.getElementById("editor_Image_src").value;
	var width=document.getElementById("editor_Image_width").value;
	var height=document.getElementById("editor_Image_height").value;
	var borderWidth=document.getElementById("editor_Image_borderWidth").value;
	var style=document.getElementById("editor_Image_style").value;
	if(width.match(/\d+ *$/)) width+="px";
	if(height.match(/\d+ *$/)) height+="px";
	if(borderWidth.match(/\d+ *$/)) borderWidth+="px";
	if(tag){
		tag.removeAttribute("style");
		tag.removeAttribute("src");
		if(src) tag.src=src;
		if(style) tag.setAttribute("style",style);
		if(width) tag.style.width=width;
		if(height) tag.style.height=height;
		if(borderWidth) tag.style.borderWidth=borderWidth;
	}else{
		var obj=document.createElement("img");
		if(src) obj.src=src;
		if(style) obj.setAttribute("style",style);
		if(width) obj.style.width=width;
		if(height) obj.style.height=height;
		if(borderWidth) obj.style.borderWidth=borderWidth;
		if(range){
			range.insertNode(obj);
		}else{
			EditorVar.HTML[i].appendChild(obj);
			EditorVar.HTML[i].appendChild(document.createElement("br"));
		}
	}
	EditorPropertyClose();
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorDivProperty(i,tag){
	if(document.getElementById("editor_Property")) return;
	EditorContextClose();
	var width,height,borderWidth,borderColor,borderStyle,color,backgroundColor,style,id,className;
	width=tag.style.width;
	height=tag.style.height;
	borderWidth=tag.style.borderWidth;
	borderStyle=tag.style.borderStyle;
	borderColor=tag.style.borderColor;
	backgroundColor=tag.style.backgroundColor;
	color=tag.style.color;
	margin=tag.style.margin;
	padding=tag.style.padding;
	style=tag.style.cssText;
	id=tag.id;
	className=tag.className;
	if(style && !style.match(/;$/)) style+=";";
	style=style.replace(/^border[^:]*:[^;]*;/ig,"");
	style=style.replace(/\sborder[^:]*:[^;]*;/ig,"");
	style=style.replace(/^color *:[^;]*;/ig,"");
	style=style.replace(/\scolor *:[^;]*;/ig,"");
	style=style.replace(/background\-color:[^;]*;/ig,"");
	style=style.replace(/^width *:[^;]*;/ig,"");
	style=style.replace(/\swidth *:[^;]*;/ig,"");
	style=style.replace(/^height *:[^;]*;/ig,"");
	style=style.replace(/\sheight *:[^;]*;/ig,"");
	style=style.replace(/^margin[^:]*:[^;]*;/ig,"");
	style=style.replace(/\smargin[^:]*:[^;]*;/ig,"");
	style=style.replace(/^padding[^:]*:[^;]*;/ig,"");
	style=style.replace(/\spadding[^:]*:[^;]*;/ig,"");
	style=style.replace(/^\s+/,"");
	style=style.replace(/\s+$/,"");
	var obj=[];
	obj[0]=document.createElement("div");
	obj[0].id="editor_Property";
	obj[0].style.backgroundColor="white";
	obj[0].style.width="100%";
	obj[0].style.height="100%";
	obj[0].style.position="absolute";
	obj[0].style.overflow="auto";
	obj[0].style.top="0px";
	obj[0].style.left="0px";
	EditorVar.HTML[i].parentNode.appendChild(obj[0]);
	obj[1]=document.createElement("div");
	obj[1].style.fontWeight="bold";
	obj[1].style.margin="10px 10px 0px";
	obj[1].appendChild(document.createTextNode("DIV設定"));
	obj[0].appendChild(obj[1]);

	obj[1]=document.createElement("span");
	obj[1].style.display="inline-block";
	obj[1].style.margin="10px";
	obj[1].style.verticalAlign="top";
	obj[3]=document.createElement("input");
	obj[3].id="editor_DIV_width";
	if(width) obj[3].value=width;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createTextNode(":width"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_DIV_height";
	if(height) obj[3].value=height;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createTextNode(":height"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_DIV_borderWidth";
	if(borderWidth) obj[3].value=borderWidth;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="ボーダー幅";
	obj[3].appendChild(document.createTextNode(":border-width"));
	obj[3].href="javascript:EditorStyleRotate('border-width','editor_DIV_borderWidth')";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_DIV_borderStyle";
	if(borderStyle) obj[3].value=borderStyle;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="ボーダー形状";
	obj[3].appendChild(document.createTextNode(":border-style"));
	obj[3].href="javascript:EditorStyleRotate('border-style','editor_DIV_borderStyle')";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_DIV_borderColor";
	if(borderColor) obj[3].value=borderColor;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="ボーダー色";
	obj[3].appendChild(document.createTextNode(":border-color"));
	obj[3].href="javascript:void(0)";
	(function(i,obj){
		if(window.addEventListener){
			obj.addEventListener('click',function(e){EditorPickerOpen(e,i,'editor_DIV_borderColor')},false);
		}else{
			obj.attachEvent('onclick',function(e){EditorPickerOpen(e,i,'editor_DIV_borderColor')});
		}
	})(i,obj[3]);
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_DIV_color";
	if(color) obj[3].value=color;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="文字色";
	obj[3].href="javascript:void(0)";
	obj[3].appendChild(document.createTextNode(":color"));
	(function(i,obj){
		if(window.addEventListener){
			obj.addEventListener('click',function(e){EditorPickerOpen(e,i,'editor_DIV_color')},false);
		}else{
			obj.attachEvent('onclick',function(e){EditorPickerOpen(e,i,'editor_DIV_color')});
		}
	})(i,obj[3]);
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_DIV_backgroundColor";
	if(backgroundColor) obj[3].value=backgroundColor;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="背景色";
	obj[3].href="javascript:void(0)";
	obj[3].appendChild(document.createTextNode(":background-color"));
	(function(i,obj){
		if(window.addEventListener){
			obj.addEventListener('click',function(e){EditorPickerOpen(e,i,'editor_DIV_backgroundColor')},false);
		}else{
			obj.attachEvent('onclick',function(e){EditorPickerOpen(e,i,'editor_DIV_backgroundColor')});
		}
	})(i,obj[3]);
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_DIV_margin";
	if(margin) obj[3].value=margin;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createTextNode(":margin"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_DIV_padding";
	if(padding) obj[3].value=padding;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createTextNode(":padding"));
	obj[1].appendChild(document.createElement("br"));
	obj[0].appendChild(obj[1]);

	obj[2]=document.createElement("span");
	obj[2].style.display="inline-block";
	obj[2].style.margin="10px";
	obj[2].style.verticalAlign="top";
	obj[3]=document.createElement("input");
	obj[3].id="editor_DIV_style";
	if(style) obj[3].value=style;
	obj[2].appendChild(obj[3]);
	obj[2].appendChild(document.createTextNode(":style"));
	obj[2].appendChild(document.createElement("br"));
	obj[2].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_DIV_id";
	if(id) obj[3].value=id;
	obj[2].appendChild(obj[3]);
	obj[2].appendChild(document.createTextNode(":id"));
	obj[2].appendChild(document.createElement("br"));
	obj[2].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_DIV_className";
	if(className) obj[3].value=className;
	obj[2].appendChild(obj[3]);
	obj[2].appendChild(document.createTextNode(":class"));
	obj[2].appendChild(document.createElement("br"));
	obj[0].appendChild(obj[2]);

	obj[1]=document.createElement("div");
	obj[1].style.margin="30px 10px 0px";
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("決定"));
	obj[2].href="javascript:void(0)";
	obj[2].id="editor_DIV_set";
	obj[1].appendChild(obj[2]);
	obj[1].appendChild(document.createTextNode("　"));
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("DIV解除"));
	obj[2].href="javascript:void(0)";
	obj[2].id="editor_TagRelease";
	obj[1].appendChild(obj[2]);
	obj[1].appendChild(document.createTextNode("　"));
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("キャンセル"));
	obj[2].href="javascript:EditorPropertyClose()";
	obj[1].appendChild(obj[2]);
	obj[0].appendChild(obj[1]);
	(function(i,tag){
		if(window.addEventListener){
			document.getElementById("editor_DIV_set").addEventListener('click',function(){EditorDivSet(i,tag)},false);
			if(document.getElementById("editor_TagRelease")) document.getElementById("editor_TagRelease").addEventListener('click',function(){EditorTagRelease(i,tag)},false);
		}else{
			document.getElementById("editor_DIV_set").attachEvent('onclick',function(){EditorDivSet(i,tag)});
			if(document.getElementById("editor_TagRelease")) document.getElementById("editor_TagRelease").attachEvent('onclick',function(){EditorTagRelease(i,tag)});
		}
	})(i,tag);
}
function EditorDivSet(i,tag){
	EditorLogUpdate(i);
	var width=document.getElementById("editor_DIV_width").value;
	var height=document.getElementById("editor_DIV_height").value;
	var borderWidth=document.getElementById("editor_DIV_borderWidth").value;
	var borderStyle=document.getElementById("editor_DIV_borderStyle").value;
	var borderColor=document.getElementById("editor_DIV_borderColor").value;
	var color=document.getElementById("editor_DIV_color").value;
	var margin=document.getElementById("editor_DIV_margin").value;
	var padding=document.getElementById("editor_DIV_padding").value;
	var backgroundColor=document.getElementById("editor_DIV_backgroundColor").value;
	var style=document.getElementById("editor_DIV_style").value;
	var id=document.getElementById("editor_DIV_id").value;
	var className=document.getElementById("editor_DIV_className").value;
	if(width.match(/\d+ *$/)) width+="px";
	if(height.match(/\d+ *$/)) height+="px";
	if(borderWidth.match(/\d+ *$/)) borderWidth+="px";
	if(margin.match(/^\d+$/)) margin+="px";
	if(padding.match(/^\d+$/)) padding+="px";
	tag.removeAttribute("style");
	if(style) tag.setAttribute("style",style);
	if(width) tag.style.width=width;
	if(height) tag.style.height=height;
	if(borderWidth) tag.style.borderWidth=borderWidth;
	if(borderStyle) tag.style.borderStyle=borderStyle;
	if(borderColor) tag.style.borderColor=borderColor;
	if(backgroundColor) tag.style.backgroundColor=backgroundColor;
	if(color) tag.style.color=color;
	if(margin) tag.style.margin=margin;
	if(padding) tag.style.padding=padding;
	if(id) tag.id=id;
	if(className) tag.className=className;
	EditorPropertyClose();
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorSpanProperty(i,tag){
	if(document.getElementById("editor_Property")) return;
	EditorContextClose();
	var fontSize,fontWeight,fontStyle,borderWidth,borderStyle,borderColor,color,backgroundColor,style,id,className;
	fontSize=tag.style.fontSize;
	fontWeight=tag.style.fontWeight;
	fontStyle=tag.style.fontStyle;
	borderWidth=tag.style.borderWidth;
	borderStyle=tag.style.borderStyle;
	borderColor=tag.style.borderColor;
	backgroundColor=tag.style.backgroundColor;
	color=tag.style.color;
	style=tag.style.cssText;
	id=tag.id;
	className=tag.className;
	if(style && !style.match(/;$/)) style+=";";
	style=style.replace(/font\-size:[^;]*;/ig,"");
	style=style.replace(/font\-weight:[^;]*;/ig,"");
	style=style.replace(/font\-style:[^;]*;/ig,"");
	style=style.replace(/^border[^:]*:[^;]*;/ig,"");
	style=style.replace(/\sborder[^:]*:[^;]*;/ig,"");
	style=style.replace(/^color *:[^;]*;/ig,"");
	style=style.replace(/\scolor *:[^;]*;/ig,"");
	style=style.replace(/background\-color:[^;]*;/ig,"");
	style=style.replace(/^\s+/,"");
	style=style.replace(/\s+$/,"");
	var obj=[];
	obj[0]=document.createElement("div");
	obj[0].id="editor_Property";
	obj[0].style.backgroundColor="white";
	obj[0].style.width="100%";
	obj[0].style.height="100%";
	obj[0].style.position="absolute";
	obj[0].style.overflow="auto";
	obj[0].style.top="0px";
	obj[0].style.left="0px";
	EditorVar.HTML[i].parentNode.appendChild(obj[0]);
	obj[1]=document.createElement("div");
	obj[1].style.fontWeight="bold";
	obj[1].style.margin="10px 10px 0px";
	obj[1].appendChild(document.createTextNode("SPAN設定"));
	obj[0].appendChild(obj[1]);

	obj[1]=document.createElement("span");
	obj[1].style.display="inline-block";
	obj[1].style.margin="10px";
	obj[1].style.verticalAlign="top";
	obj[3]=document.createElement("input");
	obj[3].id="editor_SPAN_fontSize";
	if(fontSize) obj[3].value=fontSize;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="文字の大きさ";
	obj[3].appendChild(document.createTextNode(":font-size"));
	obj[3].href="javascript:EditorStyleRotate('font-size','editor_SPAN_fontSize')";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_SPAN_fontWeight";
	if(fontWeight) obj[3].value=fontWeight;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="文字の太さ";
	obj[3].appendChild(document.createTextNode(":font-weight"));
	obj[3].href="javascript:EditorStyleRotate('font-weight','editor_SPAN_fontWeight')";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_SPAN_fontStyle";
	if(fontStyle) obj[3].value=fontStyle;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="文字の形状";
	obj[3].appendChild(document.createTextNode(":font-style"));
	obj[3].href="javascript:EditorStyleRotate('font-style','editor_SPAN_fontStyle')";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_SPAN_borderWidth";
	if(borderWidth) obj[3].value=borderWidth;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="ボーダー幅";
	obj[3].appendChild(document.createTextNode(":border-width"));
	obj[3].href="javascript:EditorStyleRotate('border-width','editor_SPAN_borderWidth')";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_SPAN_borderStyle";
	if(borderStyle) obj[3].value=borderStyle;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="ボーダー形状";
	obj[3].appendChild(document.createTextNode(":border-style"));
	obj[3].href="javascript:EditorStyleRotate('border-style','editor_SPAN_borderStyle')";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_SPAN_borderColor";
	if(borderColor) obj[3].value=borderColor;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="ボーダー色";
	obj[3].appendChild(document.createTextNode(":border-color"));
	obj[3].href="javascript:void(0)";
	(function(i,obj){
		if(window.addEventListener){
			obj.addEventListener('click',function(e){EditorPickerOpen(e,i,'editor_SPAN_borderColor')},false);
		}else{
			obj.attachEvent('onclick',function(e){EditorPickerOpen(e,i,'editor_SPAN_borderColor')});
		}
	})(i,obj[3]);
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_SPAN_color";
	if(color) obj[3].value=color;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="文字色";
	obj[3].href="javascript:void(0)";
	obj[3].appendChild(document.createTextNode(":color"));
	(function(i,obj){
		if(window.addEventListener){
			obj.addEventListener('click',function(e){EditorPickerOpen(e,i,'editor_SPAN_color')},false);
		}else{
			obj.attachEvent('onclick',function(e){EditorPickerOpen(e,i,'editor_SPAN_color')});
		}
	})(i,obj[3]);
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_SPAN_backgroundColor";
	if(backgroundColor) obj[3].value=backgroundColor;
	obj[3].style.width="100px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="背景色";
	obj[3].href="javascript:void(0)";
	obj[3].appendChild(document.createTextNode(":background-color"));
	(function(i,obj){
		if(window.addEventListener){
			obj.addEventListener('click',function(e){EditorPickerOpen(e,i,'editor_SPAN_backgroundColor')},false);
		}else{
			obj.attachEvent('onclick',function(e){EditorPickerOpen(e,i,'editor_SPAN_backgroundColor')});
		}
	})(i,obj[3]);
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[0].appendChild(obj[1]);

	obj[2]=document.createElement("span");
	obj[2].style.display="inline-block";
	obj[2].style.margin="10px";
	obj[2].style.verticalAlign="top";
	obj[3]=document.createElement("input");
	obj[3].id="editor_SPAN_style";
	if(style) obj[3].value=style;
	obj[2].appendChild(obj[3]);
	obj[2].appendChild(document.createTextNode(":style"));
	obj[2].appendChild(document.createElement("br"));
	obj[2].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_SPAN_id";
	if(id) obj[3].value=id;
	obj[2].appendChild(obj[3]);
	obj[2].appendChild(document.createTextNode(":id"));
	obj[2].appendChild(document.createElement("br"));
	obj[2].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_SPAN_className";
	if(className) obj[3].value=className;
	obj[2].appendChild(obj[3]);
	obj[2].appendChild(document.createTextNode(":class"));
	obj[2].appendChild(document.createElement("br"));
	obj[0].appendChild(obj[2]);

	obj[1]=document.createElement("div");
	obj[1].style.margin="30px 10px 0px";
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("決定"));
	obj[2].href="javascript:void(0)";
	obj[2].id="editor_SPAN_set";
	obj[1].appendChild(obj[2]);
	obj[1].appendChild(document.createTextNode("　"));
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("SPAN解除"));
	obj[2].href="javascript:void(0)";
	obj[2].id="editor_TagRelease";
	obj[1].appendChild(obj[2]);
	obj[1].appendChild(document.createTextNode("　"));
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("キャンセル"));
	obj[2].href="javascript:EditorPropertyClose()";
	obj[1].appendChild(obj[2]);
	obj[0].appendChild(obj[1]);
	(function(i,tag){
		if(window.addEventListener){
			document.getElementById("editor_SPAN_set").addEventListener('click',function(){EditorSpanSet(i,tag)},false);
			if(document.getElementById("editor_TagRelease")) document.getElementById("editor_TagRelease").addEventListener('click',function(){EditorTagRelease(i,tag)},false);
		}else{
			document.getElementById("editor_SPAN_set").attachEvent('onclick',function(){EditorSpanSet(i,tag)});
			if(document.getElementById("editor_TagRelease")) document.getElementById("editor_TagRelease").attachEvent('onclick',function(){EditorTagRelease(i,tag)});
		}
	})(i,tag);
}
function EditorSpanSet(i,tag){
	EditorLogUpdate(i);
	var fontSize=document.getElementById("editor_SPAN_fontSize").value;
	var fontWeight=document.getElementById("editor_SPAN_fontWeight").value;
	var fontStyle=document.getElementById("editor_SPAN_fontStyle").value;
	var borderWidth=document.getElementById("editor_SPAN_borderWidth").value;
	var borderStyle=document.getElementById("editor_SPAN_borderStyle").value;
	var borderColor=document.getElementById("editor_SPAN_borderColor").value;
	var color=document.getElementById("editor_SPAN_color").value;
	var backgroundColor=document.getElementById("editor_SPAN_backgroundColor").value;
	var style=document.getElementById("editor_SPAN_style").value;
	var id=document.getElementById("editor_SPAN_id").value;
	var className=document.getElementById("editor_SPAN_className").value;
	if(borderWidth.match(/\d+ *$/)) borderWidth+="px";
	tag.removeAttribute("style");
	if(style) tag.setAttribute("style",style);
	if(fontSize) tag.style.fontSize=fontSize;
	if(fontWeight) tag.style.fontWeight=fontWeight;
	if(fontStyle) tag.style.fontStyle=fontStyle;
	if(borderWidth) tag.style.borderWidth=borderWidth;
	if(borderStyle) tag.style.borderStyle=borderStyle;
	if(borderColor) tag.style.borderColor=borderColor;
	if(backgroundColor) tag.style.backgroundColor=backgroundColor;
	if(color) tag.style.color=color;
	if(id) tag.id=id;
	if(className) tag.className=className;
	EditorPropertyClose();
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorTdProperty(i,tag){
	if(document.getElementById("editor_Property")) return;
	EditorContextClose();
	var borderWidth,borderStyle,borderColor,color,backgroundColor,padding,style,id,className;
	borderWidth=tag.style.borderWidth;
	borderStyle=tag.style.borderStyle;
	borderColor=tag.style.borderColor;
	backgroundColor=tag.style.backgroundColor;
	color=tag.style.color;
	padding=tag.style.padding;
	style=tag.style.cssText;
	id=tag.id;
	className=tag.className;
	if(style && !style.match(/;$/)) style+=";";
	style=style.replace(/^border[^:]*:[^;]*;/ig,"");
	style=style.replace(/\sborder[^:]*:[^;]*;/ig,"");
	style=style.replace(/^color *:[^;]*;/ig,"");
	style=style.replace(/\scolor *:[^;]*;/ig,"");
	style=style.replace(/^padding[^:]*:[^;]*;/ig,"");
	style=style.replace(/\spadding[^:]*:[^;]*;/ig,"");
	style=style.replace(/background\-color:[^;]*;/ig,"");
	style=style.replace(/^\s+/,"");
	style=style.replace(/\s+$/,"");
	var obj=[];
	obj[0]=document.createElement("div");
	obj[0].id="editor_Property";
	obj[0].style.backgroundColor="white";
	obj[0].style.width="100%";
	obj[0].style.height="100%";
	obj[0].style.position="absolute";
	obj[0].style.overflow="auto";
	obj[0].style.top="0px";
	obj[0].style.left="0px";
	EditorVar.HTML[i].parentNode.appendChild(obj[0]);
	obj[1]=document.createElement("div");
	obj[1].style.fontWeight="bold";
	obj[1].style.margin="10px 10px 0px";
	obj[1].appendChild(document.createTextNode("セル設定"));
	obj[0].appendChild(obj[1]);

	obj[1]=document.createElement("span");
	obj[1].style.display="inline-block";
	obj[1].style.margin="10px";
	obj[1].style.verticalAlign="top";
	obj[1].appendChild(document.createTextNode("タイプ: "));
	obj[3]=document.createElement("select");
	obj[3].id="editor_TAG_celltype";
	obj[4]=document.createElement("option");
	obj[4].appendChild(document.createTextNode("<TD>"));
	obj[4].value="td";
	obj[3].appendChild(obj[4]);
	obj[4]=document.createElement("option");
	obj[4].appendChild(document.createTextNode("<TH>"));
	obj[4].value="th";
	if(tag.tagName.toUpperCase()=="TH") obj[4].selected=true;
	obj[3].appendChild(obj[4]);
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TAG_borderWidth";
	if(borderWidth) obj[3].value=borderWidth;
	obj[3].style.width="50px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createTextNode(":border-width"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TAG_borderStyle";
	if(borderStyle) obj[3].value=borderStyle;
	obj[3].style.width="50px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createTextNode(":border-style"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TAG_borderColor";
	if(borderColor) obj[3].value=borderColor;
	obj[3].style.width="50px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createTextNode(":border-color"));
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TAG_color";
	if(color) obj[3].value=color;
	obj[3].style.width="50px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="文字色";
	obj[3].href="javascript:void(0)";
	obj[3].appendChild(document.createTextNode(":color"));
	(function(i,obj){
		if(window.addEventListener){
			obj.addEventListener('click',function(e){EditorPickerOpen(e,i,'editor_TAG_color')},false);
		}else{
			obj.attachEvent('onclick',function(e){EditorPickerOpen(e,i,'editor_TAG_color')});
		}
	})(i,obj[3]);
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TAG_backgroundColor";
	if(backgroundColor) obj[3].value=backgroundColor;
	obj[3].style.width="50px";
	obj[1].appendChild(obj[3]);
	obj[3]=document.createElement("a");
	obj[3].title="背景色";
	obj[3].href="javascript:void(0)";
	obj[3].appendChild(document.createTextNode(":background-color"));
	(function(i,obj){
		if(window.addEventListener){
			obj.addEventListener('click',function(e){EditorPickerOpen(e,i,'editor_TAG_backgroundColor')},false);
		}else{
			obj.attachEvent('onclick',function(e){EditorPickerOpen(e,i,'editor_TAG_backgroundColor')});
		}
	})(i,obj[3]);
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TAG_padding";
	obj[3].value=padding||'';
	obj[3].style.width="50px";
	obj[1].appendChild(obj[3]);
	obj[1].appendChild(document.createTextNode(":padding"));
	obj[1].appendChild(document.createElement("br"));
	obj[0].appendChild(obj[1]);

	obj[2]=document.createElement("span");
	obj[2].style.display="inline-block";
	obj[2].style.margin="10px";
	obj[2].style.verticalAlign="top";
	obj[3]=document.createElement("input");
	obj[3].id="editor_TAG_style";
	if(style) obj[3].value=style;
	obj[2].appendChild(obj[3]);
	obj[2].appendChild(document.createTextNode(":style"));
	obj[2].appendChild(document.createElement("br"));
	obj[2].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TAG_id";
	if(id) obj[3].value=id;
	obj[2].appendChild(obj[3]);
	obj[2].appendChild(document.createTextNode(":id"));
	obj[2].appendChild(document.createElement("br"));
	obj[2].appendChild(document.createElement("br"));
	obj[3]=document.createElement("input");
	obj[3].id="editor_TAG_className";
	if(className) obj[3].value=className;
	obj[2].appendChild(obj[3]);
	obj[2].appendChild(document.createTextNode(":class"));
	obj[2].appendChild(document.createElement("br"));
	obj[0].appendChild(obj[2]);

	obj[1]=document.createElement("div");
	obj[1].style.margin="30px 10px 0px";
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("決定"));
	obj[2].href="javascript:void(0)";
	obj[2].id="editor_TAG_set";
	obj[1].appendChild(obj[2]);
	obj[1].appendChild(document.createTextNode("　"));
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("キャンセル"));
	obj[2].href="javascript:EditorPropertyClose()";
	obj[1].appendChild(obj[2]);
	obj[0].appendChild(obj[1]);
	(function(i,tag){
		if(window.addEventListener){
			document.getElementById("editor_TAG_set").addEventListener('click',function(){EditorTdSet(i,tag)},false);
		}else{
			document.getElementById("editor_TAG_set").attachEvent('onclick',function(){EditorTdSet(i,tag)});
		}
	})(i,tag);
}
function EditorTdSet(i,tag){
	EditorLogUpdate(i);
	var borderWidth=document.getElementById("editor_TAG_borderWidth").value;
	var borderStyle=document.getElementById("editor_TAG_borderStyle").value;
	var borderColor=document.getElementById("editor_TAG_borderColor").value;
	var color=document.getElementById("editor_TAG_color").value;
	var padding=document.getElementById("editor_TAG_padding").value;
	var backgroundColor=document.getElementById("editor_TAG_backgroundColor").value;
	var style=document.getElementById("editor_TAG_style").value;
	var id=document.getElementById("editor_TAG_id").value;
	var className=document.getElementById("editor_TAG_className").value;
	var celltype=document.getElementById("editor_TAG_celltype").value;
	if(borderWidth.match(/\d+ *$/)) borderWidth+="px";
	var ntag=document.createElement(celltype);
	while(tag.firstChild){
		ntag.appendChild(tag.removeChild(tag.firstChild));
	}
	tag.parentNode.insertBefore(ntag,tag);
	tag.parentNode.removeChild(tag);
	if(style) ntag.setAttribute("style",style);
	if(borderWidth) ntag.style.borderWidth=borderWidth;
	if(borderStyle) ntag.style.borderStyle=borderStyle;
	if(borderColor) ntag.style.borderColor=borderColor;
	if(backgroundColor) ntag.style.backgroundColor=backgroundColor;
	if(color) ntag.style.color=color;
	if(padding) ntag.style.padding=padding;
	if(id) ntag.id=id;
	if(className) ntag.className=className;
	EditorPropertyClose();
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorTrInsert(i,tag){
	if(!document.getElementById("editor_CONTEXT")) return;
	EditorLogUpdate(i);
	var tr=tag.cloneNode(true);
	for(var j=0;j<tr.childNodes.length;j++){
		if(tr.childNodes[j].tagName && (tr.childNodes[j].tagName.toUpperCase()=="TD"||tr.childNodes[j].tagName.toUpperCase()=="TH")) tr.childNodes[j].innerHTML="&nbsp;";
	}
	tag.parentNode.insertBefore(tr,tag);
	EditorContextClose();
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorTdInsert(i,tag){
	if(!document.getElementById("editor_CONTEXT")) return;
	EditorLogUpdate(i);
	var td=tag.cloneNode(true);
	td.colSpan=1;
	td.rowSpan=1;
	td.innerHTML="&nbsp;";
	var x=0;
	for(var j=0;j<tag.parentNode.childNodes.length;j++){
		if(tag.parentNode.childNodes[j]==tag) break;
		if(!tag.parentNode.childNodes[j].tagName || (tag.parentNode.childNodes[j].tagName.toUpperCase()!="TD"&&tag.parentNode.childNodes[j].tagName.toUpperCase()!="TH")) continue;
		if(tag.parentNode.childNodes[j].colSpan){
			x+=tag.parentNode.childNodes[j].colSpan;
		}else{
			x++;
		}
	}
	for(var j=0;j<tag.parentNode.parentNode.childNodes.length;j++){
		if(!tag.parentNode.parentNode.childNodes[j].tagName || tag.parentNode.parentNode.childNodes[j].tagName.toUpperCase()!="TR") continue;
		var xx=0;
		for(var k=0;k<tag.parentNode.parentNode.childNodes[j].childNodes.length;k++){
			if(!tag.parentNode.parentNode.childNodes[j].childNodes[k].tagName || (tag.parentNode.parentNode.childNodes[j].childNodes[k].tagName.toUpperCase()!="TD"&&tag.parentNode.parentNode.childNodes[j].childNodes[k].tagName.toUpperCase()!="TH")) continue;
			if(tag.parentNode.parentNode.childNodes[j].childNodes[k].colSpan){
				xx+=tag.parentNode.parentNode.childNodes[j].childNodes[k].colSpan;
			}else{
				xx++;
			}
			if(xx>x){
				tag.parentNode.parentNode.childNodes[j].insertBefore(td.cloneNode(true),tag.parentNode.parentNode.childNodes[j].childNodes[k]);
				break;
			}
		}
		if(xx<=x) tag.parentNode.parentNode.childNodes[j].appendChild(td.cloneNode(true));
	}
	EditorContextClose();
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorTdDelete(i,tag){
	if(!document.getElementById("editor_CONTEXT")) return;
	EditorLogUpdate(i);
	var x=0;
	for(var j=0;j<tag.parentNode.childNodes.length;j++){
		if(tag.parentNode.childNodes[j]==tag) break;
		if(!tag.parentNode.childNodes[j].tagName || (tag.parentNode.childNodes[j].tagName.toUpperCase()!="TD"&&tag.parentNode.childNodes[j].tagName.toUpperCase()!="TH")) continue;
		if(tag.parentNode.childNodes[j].colSpan){
			x+=tag.parentNode.childNodes[j].colSpan;
		}else{
			x++;
		}
	}
	for(var j=0;j<tag.parentNode.parentNode.childNodes.length;j++){
		if(tag.parentNode.parentNode.childNodes[j]==tag.parentNode) continue;
		if(!tag.parentNode.parentNode.childNodes[j].tagName || tag.parentNode.parentNode.childNodes[j].tagName.toUpperCase()!="TR") continue;
		var xx=0;
		for(var k=0;k<tag.parentNode.parentNode.childNodes[j].childNodes.length;k++){
			if(!tag.parentNode.parentNode.childNodes[j].childNodes[k].tagName || (tag.parentNode.parentNode.childNodes[j].childNodes[k].tagName.toUpperCase()!="TD"&&tag.parentNode.parentNode.childNodes[j].childNodes[k].tagName.toUpperCase()!="TH")) continue;
			if(tag.parentNode.parentNode.childNodes[j].childNodes[k].colSpan){
				xx+=tag.parentNode.parentNode.childNodes[j].childNodes[k].colSpan;
			}else{
				xx++;
			}
			if(xx>x){
				if(tag.parentNode.parentNode.childNodes[j].childNodes[k].colSpan && tag.parentNode.parentNode.childNodes[j].childNodes[k].colSpan>1){
					tag.parentNode.parentNode.childNodes[j].childNodes[k].colSpan-=1;
				}else{
					tag.parentNode.parentNode.childNodes[j].removeChild(tag.parentNode.parentNode.childNodes[j].childNodes[k]);
				}
				break;
			}
		}
		if(xx<=x) tag.parentNode.parentNode.childNodes[j].removeChild(tag.parentNode.parentNode.childNodes[j].lastChild);
	}
	if(tag.colSpan && tag.colSpan>1){
		tag.colSpan-=1;
	}else{
		tag.parentNode.removeChild(tag);
	}
	EditorContextClose();
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorTdRightjoin(i,tag,right){
	if(!document.getElementById("editor_CONTEXT")) return;
	EditorLogUpdate(i);
	var colSpan=tag.colSpan||1;
	colSpan++;
	tag.colSpan=colSpan;
	if(right.colSpan && right.colSpan>1){
		right.colSpan-=1;
	}else{
		right.parentNode.removeChild(right);
	}
	EditorContextClose();
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorTdBottomjoin(i,tag,bottom){
	if(!document.getElementById("editor_CONTEXT")) return;
	EditorLogUpdate(i);
	var x=tag.colSpan||1;
	var rowSpan=tag.rowSpan||1;
	rowSpan++;
	tag.rowSpan=rowSpan;
	while(bottom.lastChild){
		if(!bottom.lastChild.tagName || (bottom.lastChild.tagName.toUpperCase()!='TD'&&bottom.lastChild.tagName.toUpperCase()!='TH')){
			bottom.removeChild(bottom.lastChild);
			continue;
		}
		if(bottom.lastChild.colSpan && bottom.lastChild.colSpan>x){
			bottom.lastChild.colSpan-=x;
			break;
		}
		if(bottom.lastChild.colSpan){
			x-=bottom.lastChild.colSpan;
		}else{
			x--;
		}
		bottom.removeChild(bottom.lastChild);
		if(x==0) break;
	}
	EditorContextClose();
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorStyleRotate(style,id){
	var obj=document.getElementById(id);
	if(style=="border-width"){
		if(obj.value){
			obj.value="";
		}else{
			obj.value="1px";
		}
	}else if(style=="border-style"){
		if(!obj.value){
			obj.value="solid";
		}else if(obj.value=="solid"){
			obj.value="double";
		}else if(obj.value=="double"){
			obj.value="dashed";
		}else if(obj.value=="dashed"){
			obj.value="dotted";
		}else if(obj.value=="dotted"){
			obj.value="";
		}else{
			obj.value="";
		}
	}else if(style=="font-size"){
		if(!obj.value){
			obj.value="medium";
		}else if(obj.value=="medium"){
			obj.value="large";
		}else if(obj.value=="large"){
			obj.value="x-large";
		}else if(obj.value=="x-large"){
			obj.value="xx-large";
		}else if(obj.value=="xx-large"){
			obj.value="small";
		}else if(obj.value=="small"){
			obj.value="x-small";
		}else if(obj.value=="x-small"){
			obj.value="xx-small";
		}else if(obj.value=="xx-small"){
			obj.value="";
		}else{
			obj.value="";
		}
	}else if(style=="font-weight"){
		if(obj.value=="bold"){
			obj.value="";
		}else{
			obj.value="bold";
		}
	}else if(style=="font-style"){
		if(obj.value=="italic"){
			obj.value="";
		}else{
			obj.value="italic";
		}
	}else if(style=="target"){
		if(!obj.value){
			obj.value="_blank";
		}else{
			obj.value="";
		}
	}
}
function EditorPickerOpen(e,i,id){
	EditorPickerClose();
	if(!e) e=event;
	var obj=[];
	var rgb=[];
	var left=[];
	left[0]=0;
	left[1]=0;
	left[2]=0;
	var code="000000";
	if(document.getElementById(id).value.match(/^#([0-9a-fA-F]{2})([0-9a-fA-F]{2})([0-9a-fA-F]{2})$/)){
		code=RegExp.$1+RegExp.$2+RegExp.$3;
		left[0]=parseInt(RegExp.$1,16);
		left[1]=parseInt(RegExp.$2,16);
		left[2]=parseInt(RegExp.$3,16);
	}else if(document.getElementById(id).value.match(/^\s*rgb\(\s*(\d+)\s*,\s*(\d+)\s*,\s*(\d+)\s*\)\s*$/)){
		left[0]=parseInt(RegExp.$1).toString(16);
		left[1]=parseInt(RegExp.$2).toString(16);
		left[2]=parseInt(RegExp.$3).toString(16);
		if(left[0].length==1) left[0]="0"+left[0];
		if(left[1].length==1) left[1]="0"+left[1];
		if(left[2].length==1) left[2]="0"+left[2];
		code=left[0]+left[1]+left[2];
		left[0]=parseInt(left[0],16);
		left[1]=parseInt(left[1],16);
		left[2]=parseInt(left[2],16);
	}
	rgb[0]='R';
	rgb[1]='G';
	rgb[2]='B';
	obj[0]=document.createElement("div");
	obj[0].id="editor_Picker";
	obj[0].style.zIndex="1";
	obj[0].style.border="1px solid";
	obj[0].style.padding="5px";
	obj[0].style.backgroundColor="white";
	obj[0].style.position="fixed";
	obj[0].style.top=(e.clientY+1)+"px";
	obj[0].style.left=(e.clientX+1)+"px";
	EditorVar.HTML[i].parentNode.appendChild(obj[0]);
	for(var j=0;j<3;j++){
		obj[1]=document.createElement("div");
		obj[2]=document.createElement("span");
		obj[2].style.margin="2px 5px";
		obj[2].style.width="20px";
		obj[2].style.textAlign="center";
		obj[2].style.verticalAlign="top";
		obj[2].style.display="inline-block";
		obj[2].appendChild(document.createTextNode(rgb[j]));
		obj[1].appendChild(obj[2]);
		obj[2]=document.createElement("span");
		obj[2].style.margin="2px 5px";
		obj[2].style.width="263px";
		obj[2].style.height="15px";
		obj[2].style.verticalAlign="top";
		obj[2].style.position="relative";
		obj[2].style.display="inline-block";
		obj[3]=document.createElement("span");
		obj[3].style.width="256px";
		obj[3].style.height="1px";
		obj[3].style.position="absolute";
		obj[3].style.top="8px";
		obj[3].style.backgroundColor="black";
		obj[2].appendChild(obj[3]);
		obj[3]=document.createElement("span");
		obj[3].style.width="7px";
		obj[3].style.height="13px";
		obj[3].style.position="absolute";
		obj[3].style.top="2px";
		obj[3].style.left=left[j]+"px";
		obj[3].style.backgroundColor="gray";
		obj[3].id="editor_Picker_"+rgb[j]+"_slider";
		(function(obj,rgb){
			if(window.addEventListener){
				obj.addEventListener('mousedown',function(e){EditorPickerSlideON(e,rgb)},false);
			}else{
				obj.attachEvent('onmousedown',function(e){EditorPickerSlideON(e,rgb)});
			}
		})(obj[3],rgb[j]);
		obj[2].appendChild(obj[3]);
		obj[1].appendChild(obj[2]);
		obj[2]=document.createElement("input");
		obj[2].style.margin="2px 5px";
		obj[2].style.width="30px";
		obj[2].maxLength="3";
		obj[2].style.imeMode="disabled";
		obj[2].style.textAlign="right";
		obj[2].style.verticalAlign="middle";
		obj[2].id="editor_Picker_"+rgb[j]+"_value";
		obj[2].value=left[j];
		(function(obj,rgb){
			if(window.addEventListener){
				obj.addEventListener('change',function(){EditorPickervalueChange(rgb)},false);
			}else{
				obj.attachEvent('onchange',function(){EditorPickervalueChange(rgb)});
			}
		})(obj[2],rgb[j]);
		obj[1].appendChild(obj[2]);
		obj[0].appendChild(obj[1]);
	}
	obj[1]=document.createElement("div");
	obj[1].appendChild(document.createTextNode("コード: "));
	obj[2]=document.createElement("span");
	obj[2].appendChild(document.createTextNode("#"+code));
	obj[2].id="editor_Picker_code";
	obj[1].appendChild(obj[2]);
	obj[0].appendChild(obj[1]);
	obj[1]=document.createElement("div");
	obj[1].appendChild(document.createTextNode("サンプル: "));
	obj[2]=document.createElement("span");
	obj[2].style.display="inline-block";
	obj[2].style.width="50px";
	obj[2].style.border="1px solid black";
	obj[2].style.backgroundColor="#"+code;
	obj[2].appendChild(document.createTextNode("　"));
	obj[2].id="editor_Picker_sample";
	obj[1].appendChild(obj[2]);
	obj[0].appendChild(obj[1]);
	obj[1]=document.createElement("div");
	obj[1].style.marginTop="5px";
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("決定"));
	obj[2].href="javascript:EditorPickerSet('"+id+"')";
	obj[1].appendChild(obj[2]);
	obj[1].appendChild(document.createTextNode("　"));
	obj[2]=document.createElement("a");
	obj[2].appendChild(document.createTextNode("キャンセル"));
	obj[2].href="javascript:EditorPickerClose()";
	obj[1].appendChild(obj[2]);
	obj[0].appendChild(obj[1]);
}
function EditorPickervalueChange(rgb){
	var x=document.getElementById("editor_Picker_"+rgb+"_value").value;
	if(x.match(/\D/)) x=255;
	x=parseInt(x);
	if(x<0) x=0;
	if(x>255) x=255;
	document.getElementById("editor_Picker_"+rgb+"_value").value=x;
	document.getElementById("editor_Picker_"+rgb+"_slider").style.left=x+"px";
	EditorPickerUpdate();
}
function EditorPickerSlideON(e,rgb){
	if(!e) e=event;
	EditorVar.sliderX=e.clientX;
	EditorVar.sliderRGB=rgb;
	if(window.addEventListener){
		document.getElementById("editor_Picker").addEventListener('mousemove',EditorPickerSlideMove,false);
		document.getElementById("editor_Picker").addEventListener('mouseup',EditorPickerSlideOFF,false);
		e.preventDefault();
	}else{
		document.getElementById("editor_Picker").attachEvent('onmousemove',EditorPickerSlideMove);
		document.getElementById("editor_Picker").attachEvent('onmouseup',EditorPickerSlideOFF);
		e.returnValue=false;
	}
}
function EditorPickerSlideMove(e){
	if(!e) e=event;
	var x=parseInt(document.getElementById("editor_Picker_"+EditorVar.sliderRGB+"_value").value);
	x+=e.clientX-EditorVar.sliderX;
	EditorVar.sliderX=e.clientX;
	if(x<0 || x>255){
		if(x<0) x=0;
		if(x>255) x=255;
		if(window.addEventListener){
			document.getElementById("editor_Picker").removeEventListener("mousemove",EditorPickerSlideMove,false);
			document.getElementById("editor_Picker").removeEventListener("mouseup",EditorPickerSlideOFF,false);
		}else{
			document.getElementById("editor_Picker").detachEvent("onmousemove",EditorPickerSlideMove);
			document.getElementById("editor_Picker").detachEvent("onmouseup",EditorPickerSlideOFF);
	  }
	}
	document.getElementById("editor_Picker_"+EditorVar.sliderRGB+"_value").value=x;
	document.getElementById("editor_Picker_"+EditorVar.sliderRGB+"_slider").style.left=x+"px";
	EditorPickerUpdate();
}
function EditorPickerSlideOFF(){
	if(window.addEventListener){
		document.getElementById("editor_Picker").removeEventListener("mousemove",EditorPickerSlideMove,false);
		document.getElementById("editor_Picker").removeEventListener("mouseup",EditorPickerSlideOFF,false);
	}else{
		document.getElementById("editor_Picker").detachEvent("onmousemove",EditorPickerSlideMove);
		document.getElementById("editor_Picker").detachEvent("onmouseup",EditorPickerSlideOFF);
  }
	EditorPickerUpdate();
}
function EditorPickerUpdate(){
	var v=[];
	v[0]=parseInt(document.getElementById("editor_Picker_R_value").value).toString(16);
	v[1]=parseInt(document.getElementById("editor_Picker_G_value").value).toString(16);
	v[2]=parseInt(document.getElementById("editor_Picker_B_value").value).toString(16);
	if(v[0].length==1) v[0]="0"+v[0];
	if(v[1].length==1) v[1]="0"+v[1];
	if(v[2].length==1) v[2]="0"+v[2];
	var code=v[0]+v[1]+v[2];
	document.getElementById("editor_Picker_code").innerHTML="#"+code;
	document.getElementById("editor_Picker_sample").style.backgroundColor="#"+code;
}
function EditorPickerSet(id){
	var v=[];
	v[0]=parseInt(document.getElementById("editor_Picker_R_value").value).toString(16);
	v[1]=parseInt(document.getElementById("editor_Picker_G_value").value).toString(16);
	v[2]=parseInt(document.getElementById("editor_Picker_B_value").value).toString(16);
	if(v[0].length==1) v[0]="0"+v[0];
	if(v[1].length==1) v[1]="0"+v[1];
	if(v[2].length==1) v[2]="0"+v[2];
	var code=v[0]+v[1]+v[2];
	document.getElementById(id).value="#"+code;
	EditorPickerClose();
}
function EditorPickerClose(){
	if(document.getElementById("editor_Picker")) document.getElementById("editor_Picker").parentNode.removeChild(document.getElementById("editor_Picker"));
}
function EditorTagDelete(i,tag){
	EditorLogUpdate(i);
	tag.parentNode.removeChild(tag);
	EditorContextClose();
	EditorPropertyClose();
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorTagRelease(i,tag){
	EditorLogUpdate(i);
	while(tag.firstChild){
		tag.parentNode.insertBefore(tag.removeChild(tag.firstChild),tag);
	}
	tag.parentNode.removeChild(tag);
	EditorContextClose();
	EditorPropertyClose();
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorPropertyClose(){
	EditorPickerClose();
	if(document.getElementById("editor_Property")) document.getElementById("editor_Property").parentNode.removeChild(document.getElementById("editor_Property"));
}
function EditorContextOpen(e,i){
	EditorContextClose();
	if(!e){
		e=event;
	}
	var obj=[];
	obj[0]=document.createElement("div");
	obj[0].id="editor_CONTEXT";
	obj[0].style.zIndex="1";
	obj[0].style.border="1px solid";
	obj[0].style.backgroundColor="white";
	obj[0].style.position="fixed";
	obj[0].style.top=(e.clientY+1)+"px";
	obj[0].style.left=(e.clientX+1)+"px";
	EditorVar.HTML[i].parentNode.appendChild(obj[0]);
	obj[1]=document.createElement("div");
	obj[1].style.padding="2px 10px";
	obj[1].style.cursor="default";
	obj[1].appendChild(document.createTextNode("元に戻す"));
	obj[0].appendChild(obj[1]);
	if(EditorVar.now[i]){
		(function(obj,i){
			if(window.addEventListener){
				obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
				obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
				obj.addEventListener('mouseup',function(){EditorUndo(i)},false);
				obj.addEventListener('click',function(){EditorUndo(i)},false);
			}else{
				obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
				obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
				obj.attachEvent('onmouseup',function(){EditorUndo(i)});
				obj.attachEvent('onclick',function(){EditorUndo(i)});
			}
		})(obj[1],i);
	}else{
		obj[1].style.color="gray";
	}
	obj[1]=document.createElement("div");
	obj[1].style.padding="2px 10px";
	obj[1].style.cursor="default";
	obj[1].appendChild(document.createTextNode("やり直す"));
	obj[0].appendChild(obj[1]);
	if(EditorVar.now[i]+1<EditorVar.log[i].length){
		(function(obj,i){
			if(window.addEventListener){
				obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
				obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
				obj.addEventListener('mouseup',function(){EditorRedo(i)},false);
				obj.addEventListener('click',function(){EditorRedo(i)},false);
			}else{
				obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
				obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
				obj.attachEvent('onmouseup',function(){EditorRedo(i)});
				obj.attachEvent('onclick',function(){EditorRedo(i)});
			}
		})(obj[1],i);
	}else{
		obj[1].style.color="gray";
	}
	obj[1]=document.createElement('div');
	obj[1].style.height="1px";
	obj[1].style.margin="0px 3px";
	obj[1].style.borderBottom="1px solid";
	obj[0].appendChild(obj[1]);
	var node=e.target||e.srcElement;
	if(EditorVar.HTML[i].contains(node)){
		var tag;
		var checked=[];
		node=e.target||e.srcElement;
		while(node && node!=EditorVar.HTML[i]){
			tag=node.tagName.toUpperCase();
			if(checked[tag]){
				node=node.parentNode;
				continue;
			}
			checked[tag]=1;
			if(tag=="B" || tag=="I" || tag=="U" || tag=="S"){
				obj[1]=document.createElement("div");
				obj[1].style.padding="2px 10px";
				obj[1].style.cursor="default";
				obj[1].appendChild(document.createTextNode("<"+tag+">解除"));
				(function(obj,i,node){
					if(window.addEventListener){
						obj.addEventListener('click',function(){EditorTagRelease(i,node)},false);
						obj.addEventListener('mouseup',function(){EditorTagRelease(i,node)},false);
						obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
						obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
					}else{
						obj.attachEvent('onclick',function(){EditorTagRelease(i,node)});
						obj.attachEvent('onmouseup',function(){EditorTagRelease(i,node)});
						obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
						obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
					}
				})(obj[1],i,node);
				obj[0].appendChild(obj[1]);
			}else if(tag=="LI"){
				obj[1]=document.createElement("div");
				obj[1].style.padding="2px 10px";
				obj[1].style.cursor="default";
				obj[1].appendChild(document.createTextNode("手前にリスト行追加"));
				(function(obj,i,node){
					if(window.addEventListener){
						obj.addEventListener('click',function(){EditorListAdd(i,node)},false);
						obj.addEventListener('mouseup',function(){EditorListAdd(i,node)},false);
						obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
						obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
					}else{
						obj.attachEvent('onclick',function(){EditorListAdd(i,node)});
						obj.attachEvent('onmouseup',function(){EditorListAdd(i,node)});
						obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
						obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
					}
				})(obj[1],i,node);
				obj[0].appendChild(obj[1]);
			}else if(tag=="A"){
				obj[1]=document.createElement("div");
				obj[1].style.padding="2px 10px";
				obj[1].style.cursor="default";
				obj[1].appendChild(document.createTextNode("<A>設定"));
				(function(obj,i,node){
					if(window.addEventListener){
						obj.addEventListener('click',function(){EditorLinkProperty(i,node)},false);
						obj.addEventListener('mouseup',function(){EditorLinkProperty(i,node)},false);
						obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
						obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
					}else{
						obj.attachEvent('onclick',function(){EditorLinkProperty(i,node)});
						obj.attachEvent('onmouseup',function(){EditorLinkProperty(i,node)});
						obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
						obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
					}
				})(obj[1],i,node);
				obj[0].appendChild(obj[1]);
			}else if(tag=="IMG"){
				obj[1]=document.createElement("div");
				obj[1].style.padding="2px 10px";
				obj[1].style.cursor="default";
				obj[1].appendChild(document.createTextNode("<IMG>設定"));
				(function(obj,i,node){
					if(window.addEventListener){
						obj.addEventListener('click',function(){EditorImageProperty(i,node)},false);
						obj.addEventListener('mouseup',function(){EditorImageProperty(i,node)},false);
						obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
						obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
					}else{
						obj.attachEvent('onclick',function(){EditorImageProperty(i,node)});
						obj.attachEvent('onmouseup',function(){EditorImageProperty(i,node)});
						obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
						obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
					}
				})(obj[1],i,node);
				obj[0].appendChild(obj[1]);
			}else if(tag=="TABLE"){
				obj[1]=document.createElement("div");
				obj[1].style.padding="2px 10px";
				obj[1].style.cursor="default";
				obj[1].appendChild(document.createTextNode("<TABLE>設定"));
				(function(obj,i,node){
					if(window.addEventListener){
						obj.addEventListener('click',function(){EditorTableProperty(i,node)},false);
						obj.addEventListener('mouseup',function(){EditorTableProperty(i,node)},false);
						obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
						obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
					}else{
						obj.attachEvent('onclick',function(){EditorTableProperty(i,node)});
						obj.attachEvent('onmouseup',function(){EditorTableProperty(i,node)});
						obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
						obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
					}
				})(obj[1],i,node);
				obj[0].appendChild(obj[1]);
			}else if(tag=="DIV"){
				obj[1]=document.createElement("div");
				obj[1].style.padding="2px 10px";
				obj[1].style.cursor="default";
				obj[1].appendChild(document.createTextNode("<DIV>設定"));
				(function(obj,i,node){
					if(window.addEventListener){
						obj.addEventListener('click',function(){EditorDivProperty(i,node)},false);
						obj.addEventListener('mouseup',function(){EditorDivProperty(i,node)},false);
						obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
						obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
					}else{
						obj.attachEvent('onclick',function(){EditorDivProperty(i,node)});
						obj.attachEvent('onmouseup',function(){EditorDivProperty(i,node)});
						obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
						obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
					}
				})(obj[1],i,node);
				obj[0].appendChild(obj[1]);
			}else if(tag=="SPAN"){
				obj[1]=document.createElement("div");
				obj[1].style.padding="2px 10px";
				obj[1].style.cursor="default";
				obj[1].appendChild(document.createTextNode("<SPAN>設定"));
				(function(obj,i,node){
					if(window.addEventListener){
						obj.addEventListener('click',function(){EditorSpanProperty(i,node)},false);
						obj.addEventListener('mouseup',function(){EditorSpanProperty(i,node)},false);
						obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
						obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
					}else{
						obj.attachEvent('onclick',function(){EditorSpanProperty(i,node)});
						obj.attachEvent('onmouseup',function(){EditorSpanProperty(i,node)});
						obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
						obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
					}
				})(obj[1],i,node);
				obj[0].appendChild(obj[1]);
			}else if(tag=="TD" || tag=="TH"){
				obj[1]=document.createElement("div");
				obj[1].style.padding="2px 10px";
				obj[1].style.cursor="default";
				obj[1].appendChild(document.createTextNode("セル設定"));
				(function(obj,i,node){
					if(window.addEventListener){
						obj.addEventListener('click',function(){EditorTdProperty(i,node)},false);
						if(!window.execScript && navigator.userAgent.indexOf("Safari")==-1) obj.addEventListener('mouseup',function(){EditorTdProperty(i,node)},false);
						obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
						obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
					}else{
						obj.attachEvent('onclick',function(){EditorTdProperty(i,node)});
						obj.attachEvent('onmouseup',function(){EditorTdProperty(i,node)});
						obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
						obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
					}
				})(obj[1],i,node);
				obj[0].appendChild(obj[1]);
				obj[1]=document.createElement("div");
				obj[1].style.padding="2px 10px";
				obj[1].style.cursor="default";
				obj[1].appendChild(document.createTextNode("列追加"));
				(function(obj,i,node){
					if(window.addEventListener){
						obj.addEventListener('click',function(){EditorTdInsert(i,node)},false);
						obj.addEventListener('mouseup',function(){EditorTdInsert(i,node)},false);
						obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
						obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
					}else{
						obj.attachEvent('onclick',function(){EditorTdInsert(i,node)});
						obj.attachEvent('onmouseup',function(){EditorTdInsert(i,node)});
						obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
						obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
					}
				})(obj[1],i,node);
				obj[0].appendChild(obj[1]);
				obj[0].appendChild(obj[1]);
				obj[1]=document.createElement("div");
				obj[1].style.padding="2px 10px";
				obj[1].style.cursor="default";
				obj[1].appendChild(document.createTextNode("列削除"));
				(function(obj,i,node){
					if(window.addEventListener){
						obj.addEventListener('click',function(){EditorTdDelete(i,node)},false);
						obj.addEventListener('mouseup',function(){EditorTdDelete(i,node)},false);
						obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
						obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
					}else{
						obj.attachEvent('onclick',function(){EditorTdDelete(i,node)});
						obj.attachEvent('onmouseup',function(){EditorTdDelete(i,node)});
						obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
						obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
					}
				})(obj[1],i,node);
				obj[0].appendChild(obj[1]);
				var right;
				for(var j=0;j<node.parentNode.childNodes.length;j++){
					if(node.parentNode.childNodes[j]!=node) continue;
					for(k=j+1;k<node.parentNode.childNodes.length;k++){
						if(node.parentNode.childNodes[k].tagName && (node.parentNode.childNodes[k].tagName.toUpperCase()=="TD"||node.parentNode.childNodes[k].tagName.toUpperCase()=="TH")){
							right=node.parentNode.childNodes[k];
							break;
						}
					}
					break;
				}
				if(right&&((node.rowSpan&&node.rowSpan>1)||(right.rowSpan&&right.rowSpan>1))) right="";
				if(right){
					obj[1]=document.createElement("div");
					obj[1].style.padding="2px 10px";
					obj[1].style.cursor="default";
					obj[1].appendChild(document.createTextNode("右のセルと統合"));
					(function(obj,i,node,right){
						if(window.addEventListener){
							obj.addEventListener('click',function(){EditorTdRightjoin(i,node,right)},false);
							obj.addEventListener('mouseup',function(){EditorTdRightjoin(i,node,right)},false);
							obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
							obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
						}else{
							obj.attachEvent('onclick',function(){EditorTdRightjoin(i,node,right)});
							obj.attachEvent('onmouseup',function(){EditorTdRightjoin(i,node,right)});
							obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
							obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
						}
					})(obj[1],i,node,right);
					obj[0].appendChild(obj[1]);
				}
				var bottom;
				var y=node.rowSpan||1;
				for(var j=0;j<node.parentNode.parentNode.childNodes.length;j++){
					if(node.parentNode.parentNode.childNodes[j]!=node.parentNode) continue;
					for(k=j+1;k<node.parentNode.parentNode.childNodes.length;k++){
						if(node.parentNode.parentNode.childNodes[k].tagName && node.parentNode.parentNode.childNodes[k].tagName.toUpperCase()=="TR"){
							y--;
							if(y==0){
								bottom=node.parentNode.parentNode.childNodes[k];
								break;
							}
						}
					}
					break;
				}
				if(bottom){
					obj[1]=document.createElement("div");
					obj[1].style.padding="2px 10px";
					obj[1].style.cursor="default";
					obj[1].appendChild(document.createTextNode("下のセルと統合"));
					(function(obj,i,node,bottom){
						if(window.addEventListener){
							obj.addEventListener('click',function(){EditorTdBottomjoin(i,node,bottom)},false);
							obj.addEventListener('mouseup',function(){EditorTdBottomjoin(i,node,bottom)},false);
							obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
							obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
						}else{
							obj.attachEvent('onclick',function(){EditorTdBottomjoin(i,node,bottom)});
							obj.attachEvent('onmouseup',function(){EditorTdBottomjoin(i,node,bottom)});
							obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
							obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
						}
					})(obj[1],i,node,bottom);
					obj[0].appendChild(obj[1]);
				}
			}else if(tag=="TR"){
				obj[1]=document.createElement("div");
				obj[1].style.padding="2px 10px";
				obj[1].style.cursor="default";
				obj[1].appendChild(document.createTextNode("行追加"));
				(function(obj,i,node){
					if(window.addEventListener){
						obj.addEventListener('click',function(){EditorTrInsert(i,node)},false);
						obj.addEventListener('mouseup',function(){EditorTrInsert(i,node)},false);
						obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
						obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
					}else{
						obj.attachEvent('onclick',function(){EditorTrInsert(i,node)});
						obj.attachEvent('onmouseup',function(){EditorTrInsert(i,node)});
						obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
						obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
					}
				})(obj[1],i,node);
				obj[0].appendChild(obj[1]);
				obj[1]=document.createElement("div");
				obj[1].style.padding="2px 10px";
				obj[1].style.cursor="default";
				obj[1].appendChild(document.createTextNode("行削除"));
				(function(obj,i,node){
					if(window.addEventListener){
						obj.addEventListener('click',function(){EditorTagDelete(i,node)},false);
						obj.addEventListener('mouseup',function(){EditorTagDelete(i,node)},false);
						obj.addEventListener('mouseover',function(){obj.style.backgroundColor="whitesmoke"},false);
						obj.addEventListener('mouseout',function(){obj.style.backgroundColor="white"},false);
					}else{
						obj.attachEvent('onclick',function(){EditorTagDelete(i,node)});
						obj.attachEvent('onmouseup',function(){EditorTagDelete(i,node)});
						obj.attachEvent('onmouseover',function(){obj.style.backgroundColor="whitesmoke"});
						obj.attachEvent('onmouseout',function(){obj.style.backgroundColor="white"});
					}
				})(obj[1],i,node);
				obj[0].appendChild(obj[1]);
			}
			node=node.parentNode;
		}
	}
	if(window.addEventListener){
		window.addEventListener("mousemove",EditorContextCloseSet,true);
		e.preventDefault();
	}else{
		window.document.attachEvent("onmousemove",EditorContextCloseSet);
		e.returnValue=false;
  }
}
function EditorContextCloseSet(){
	if(window.addEventListener){
		window.addEventListener("click",EditorContextClose,true);
		window.removeEventListener("mousemove",EditorContextCloseSet,true);
	}else{
		window.document.attachEvent("onclick",EditorContextClose);
		window.document.detachEvent("onmousemove",EditorContextCloseSet);
  }
}
function EditorContextClose(){
	if(document.getElementById("editor_CONTEXT")) document.getElementById("editor_CONTEXT").parentNode.removeChild(document.getElementById("editor_CONTEXT"));
	if(window.removeEventListener){
		window.removeEventListener("click",EditorContextClose,true);
	}else{
		window.document.detachEvent("onclick",EditorContextClose);
	}
}
function EditorInlineInsert(i,tag){
	if(!window.getSelection){
		var range=document.selection.createRange();
		if(document.selection.type=='Text'){
			var str=range.text.replace(/\n/,"<br />");
			range.pasteHTML("<"+tag.toLowerCase()+">"+str+"</"+tag.toLowerCase()+">");
			EditorLogUpdate(i);
			EditorTextareaUpdate(i);
		}
		return;
	}
	var sel=getSelection();
	var range=sel.getRangeAt(0);
	var node=range.commonAncestorContainer;
	if(!EditorVar.HTML[i].contains(node) || range.collapsed) return;
	EditorLogUpdate(i);
	var obj=document.createElement(tag);
	obj.appendChild(range.extractContents());
	range.insertNode(obj);
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorBlockInsert(i,tag){
	if(!window.getSelection){
		var range=document.selection.createRange();
		if(document.selection.type=='Text'){
			var str=range.text.replace(/\n/,"<br />");
			range.pasteHTML("<"+tag.toLowerCase()+">"+str+"</"+tag.toLowerCase()+">");
			EditorLogUpdate(i);
			EditorTextareaUpdate(i);
		}
		return;
	}
	var sel=getSelection();
	var range=sel.getRangeAt(0);
	var obj,block,str;
	var node=range.commonAncestorContainer;
	if(!EditorVar.HTML[i].contains(node) || range.collapsed) return;
	EditorLogUpdate(i);
	block=document.createElement(tag);
	block.appendChild(range.extractContents());
	range.insertNode(block);
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorListInsert(i,tag){
	if(!window.getSelection){
		var range=document.selection.createRange();
		if(document.selection.type=='Text'){
			var line=range.text.split(/\n/);
			var str="";
			for(var j=0;j<line.length;j++){
				str+="<li>"+line[j]+"</li>";
			}
			range.pasteHTML("<"+tag.toLowerCase()+">"+str+"</"+tag.toLowerCase()+">");
			EditorLogUpdate(i);
			EditorTextareaUpdate(i);
		}
		return;
	}
	var sel=getSelection();
	var range=sel.getRangeAt(0);
	var obj,list,str;
	var node=range.commonAncestorContainer;
	if(!EditorVar.HTML[i].contains(node)) return;
	EditorLogUpdate(i);
	list=document.createElement(tag);
	obj=document.createElement("li");
	list.appendChild(obj);
	obj.appendChild(range.extractContents());
	if(obj.innerHTML.match(/^\s*$/)) obj.innerHTML="&nbsp;";
	for(var j=0;j<obj.childNodes.length;j++){
		if(obj.childNodes[j].nodeType==1 && obj.childNodes[j].tagName.toUpperCase()=="BR"){
			obj.removeChild(obj.childNodes[j]);
			var tmp=document.createElement("li");
			while(obj.childNodes[j]){
				tmp.appendChild(obj.removeChild(obj.childNodes[j]));
			}
			if(obj.innerHTML.match(/^\s*$/)) obj.innerHTML="&nbsp;";
			obj=tmp;
			if(obj.innerHTML.match(/^\s*$/)) obj.innerHTML="&nbsp;";
			list.appendChild(obj);
			j=0;
		}
	}
	range.insertNode(list);
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorListAdd(i,target){
	EditorLogUpdate(i);
	var li=document.createElement('li');
	li.innerHTML='&nbsp;';
	target.parentNode.insertBefore(li,target);
	EditorContextClose();
	EditorLogUpdate(i);
	EditorTextareaUpdate(i);
}
function EditorHtmlInsert(i){
	var code=EditorVar.Textarea[i].value;
	if(!window.addEventListener){
		EditorVar.HTML[i].innerHTML=code;
		return;
	}
	var m=code.match(/<[^>]+\son\w+\s*=[^>]+>/ig);
	for(var j=0;m&&j<m.length;j++){
		var mm=m[j].match(/\son\w+\s*=/ig);
		for(var k=0;mm&&k<mm.length;k++){
			mm[k].match(/\son(\w+)\s*=/i);
			var t=RegExp.$1.toLowerCase();
			if(!EditorVar.EventStoped[i][t]){
				EditorVar.HTML[i].addEventListener(t,function(e){e.stopPropagation()},true);
				EditorVar.EventStoped[i][t]=1;
			}
		}
	}
	if(code==''){
		EditorVar.HTML[i].innerHTML='<br>';
	}else{
		EditorVar.HTML[i].innerHTML=code;
	}
}
function EditorModeChange(i){
	if(EditorVar.Textarea[i].style.display=="none"){
		EditorTextareaUpdate(i);
		EditorVar.Textarea[i].style.display="block";
		EditorVar.HTML[i].style.display="none";
		document.getElementById("editor_"+i+"_BUTTON_mode").innerHTML="プレビュー";
	}else{
		EditorLogUpdate(i);
		EditorHtmlInsert(i);
		EditorVar.Textarea[i].style.display="none";
		EditorVar.HTML[i].style.display="block";
		document.getElementById("editor_"+i+"_BUTTON_mode").innerHTML="ソース";
	}
}

